

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## init.py
#
# This script run one time at the begining and set:
#    variable
#    dictionary
#    find my IP
#    All variable are saved in gl
#############################################################################

import GameLogic as gl

import subprocess,re, socket
from functools import reduce

# Variable set as attribut of GameLogic
gl.connected = False # if socket Get OSC is conected or not
gl.tp = 0 # Tempo on 60 frames = 1 second for some script, run always and reinit in get_osc.py
gl.data = [] # data from get_osc.py
gl.players_data = [] # players_data list
gl.level_change = 0 # change with new player or quiting player
gl.level = 1 # player number
gl.Iam = 0 # my position in players_data list
gl.my_name = "toto" # my default name
gl.name = {} # Used in rank_display {Name : rank}
gl.ranked = False # To be ranked only once
gl.tempo = 0 # Used in game.py with Rank
gl.block = 0 # Used in game.py with Rank
gl.rank_machine = 0 # Used to set fictive player in level 1
gl.text = 'rien'

## Used in scene_object.py
# All bat
gl.bat = {  0 : 0,
            1 : 1,
            2 : 2,
            3 : 3,
            4 : 4,
            5 : 5,
            6 : 6,
            7 : 7,
            8 : 8,
            9 : 9}

# All goal to access score
gl.goal = {  0 : 0,
            1 : 1,
            2 : 2,
            3 : 3,
            4 : 4,
            5 : 5,
            6 : 6,
            7 : 7,
            8 : 8,
            9 : 9   }

## Players added with [A], deleted with [Z]
# Simul players to debug
gl.simul = [['192.168.1.2',  '/ball', 0 ,0 , '/bat', 0, 3, '/score', 5, '/name', 'labomedia', '/rank', 0],
            ['192.168.1.6',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 9, '/name', 'toto', '/rank', 0],
            ['192.168.1.7',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 8, '/name', 'yoyo', '/rank', 4],
            ['192.168.1.8',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 7, '/name', 'amour', '/rank', 0],
            ['192.168.1.9',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 6, '/name', 'freedom', '/rank', 6],
            ['192.168.1.3',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 5, '/name', 'tata', '/rank', 7],
            ['192.168.1.5',  '/ball', 0 ,0 , '/bat', 0, 0, '/score', 4, '/name', 'titi', '/rank', 8],
            ['192.168.1.12', '/ball', 0 ,0 , '/bat', 0, 0, '/score', 3, '/name', 'arts', '/rank', 9],
            ['192.168.1.14', '/ball', 0 ,0 , '/bat', 0, 0, '/score', 3, '/name', 'num', '/rank', 10] ]

# -------------  Get local ip  ---------------- #
#A generator that returns stripped lines of output from "ip address show"
iplines=(line.strip() for line in subprocess.getoutput("ip address show").split('\n'))

#Turn that into a list of IPv4 and IPv6 address/mask strings
addresses1=reduce(lambda a,v:a+v,(re.findall(r"inet ([\d.]+/\d+)",line)+re.findall(r"inet6 ([\:\da-f]+/\d+)",line) for line in iplines))

#Get a list of IPv4 addresses as (IPstring,subnetsize) tuples
ipv4s=[(ip,int(subnet)) for ip,subnet in (addr.split('/') for addr in addresses1 if '.' in addr)]

# my IP
gl.local_ip = ipv4s[1][0]
print("Your ip is :", gl.local_ip)
